-- frmMain.lua
-- Written by Habna
--- Add locking postition, cause when clicking a bit faster sometime it's not clicking cause the utilitie is moving instead
-- Some time have to click twice to do the click event wierd


import "HabnaPlugins.HugeBag.Utilities.settings"; -- LUA Menu file
import "HabnaPlugins.HugeBag.Utilities.functions"; -- LUA Menu file
import "HabnaPlugins.HugeBag.Utilities.menu"; -- LUA Menu file

function frmMain()
	self = Turbine.UI.Window();
	self.WasDrag = false;
	self:SetSize( 32, 32 );
	screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	WWidth, WHeight = self:GetSize();
	
	LoadSettings();
	
	self:SetPosition( WLocX, WLocY );
	self:SetVisible( true );

	reloadButton = Turbine.UI.Button();
	reloadButton:SetParent( self );
	reloadButton:SetPosition( 0, 0 );
	reloadButton:SetSize( self:GetWidth(), self:GetHeight() );
	reloadButton:SetBackground( "HabnaPlugins/HugeBag/Resources/reload32.tga" );

	reloadButton.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			if ( not self.WasDrag ) then
				ReloadHugeBag();
			end
		else
			menu:ShowMenu();
		end
		self.WasDrag = false;
	end

	reloadButton.MouseDown = function( sender, args )
		self.dragStartX = args.X;
		self.dragStartY = args.Y;
		self.dragging = true;
	end
	
	reloadButton.MouseUp = function( sender, args )
		local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
		if self:GetLeft() < 0 then self:SetLeft( 0 ) end
		if self:GetLeft() + self:GetWidth() > screenWidth then self:SetLeft( screenWidth - self:GetWidth() ) end
		if self:GetTop() < 0 then self:SetTop( 0 ) end
		if self:GetTop() + self:GetHeight() > screenHeight then self:SetTop( screenHeight - self:GetHeight() ) end
		self.dragging = false;
		SaveSettings();
	end
	
	reloadButton.MouseMove = function( sender, args )
		local left, top = self:GetPosition();
		
  		if not Lock then
			if ( self.dragging ) then
				self:SetPosition( left + ( args.X - self.dragStartX ), top + ( args.Y - self.dragStartY ) );
				self.WasDrag = true;
			end
		end
	end
end