-- functions.lua
-- Written By Habna


-- **v Reload HugeBag v**
function ReloadHugeBag()
	Turbine.PluginManager.RefreshAvailablePlugins()
	local loaded_plugins = Turbine.PluginManager.GetLoadedPlugins()
	local foundHugeBag = false;

	for k,v in pairs(loaded_plugins) do
		if v.Name == "HugeBag" then
			foundHugeBag = true;
		end
	end

	if foundHugeBag then
		Turbine.PluginManager.UnloadScriptState( "HugeBag" );
		Turbine.PluginManager.LoadPlugin("HugeBag");
		write( "HugeBag Utilities: HugeBag was reloaded" );
	else
		Turbine.PluginManager.LoadPlugin("HugeBag");
		write( "HugeBag Utilities: HugeBag was loaded" );
	end
end
-- **^

-- **v Reset Location v**
function ResetLoc()
	local screenWidth, screenHeight = Turbine.UI.Display.GetSize()
	local winWidth, winHeight = self:GetSize();
	self:SetPosition( screenWidth - winWidth - 90, screenHeight - winHeight - 40 );
	SaveSettings();
end
-- **^

-- **v Reset Location v**
function ToggleLock()
	Lock = not Lock;
	SaveSettings();
	if Lock then
		write( "HugeBagUtility: my position is now lock" );
	else
		write( "HugeBagUtility: my position is now unlock" );
	end
end
-- **^